# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section         free

Name:           tapestry4
Version:        4.1.6
Release:        1%{?dist}
Epoch:          0
Summary:        Tapestry Framework
License:        Apache Software License 2.0
Group:          Development/Libraries/Java
Url:            http://tapestry.apache.org/
Source0:        tapestry4-4.1.6.tgz
# svn export http://svn.apache.org/repos/asf/tapestry/tapestry4/tags/4.1.6-final-corrected/ tapestry4-4.1.6
# tar czf tapestry4-4.1.6.tgz tapestry4-4.1.6/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Patch0:         %{name}-pom.patch
Patch1:         %{name}-ChartService.patch
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7
BuildRequires:  apache-commons-dbcp
BuildRequires:  apache-commons-fileupload
BuildRequires:  apache-commons-pool
BuildRequires:  apache-portlet-1.0-api
BuildRequires:  backport-util-concurrent
BuildRequires:  easymock-classextension2
BuildRequires:  geronimo-j2ee-1.4-apis
BuildRequires:  geronimo-genesis
BuildRequires:  geronimo-servlet-2.5-api
BuildRequires:  hivemind
BuildRequires:  hivemind-lib
BuildRequires:  hsqldb
BuildRequires:  javassist
BuildRequires:  jcharts
BuildRequires:  jetty5
BuildRequires:  jetty6-maven2-plugins
BuildRequires:  ognl >= 0:2.7.3
BuildRequires:  openqa-selenium-core
BuildRequires:  openqa-selenium-rc-java-client-driver
BuildRequires:  openqa-selenium-rc-server
BuildRequires:  openqa-selenium-rc-server-coreless
BuildRequires:  testng
BuildRequires:  apache-commons-parent >= 0:12
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-war
BuildRequires:  maven2-default-skin
BuildRequires:  mojo-maven2-plugin-clirr
BuildRequires:  mojo-maven2-plugin-cobertura
Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:       java >= 0:1.6.0
Requires:       apache-commons-dbcp
Requires:       apache-commons-fileupload
Requires:       apache-commons-pool
Requires:       apache-portlet-1.0-api
Requires:       backport-util-concurrent
Requires:       hivemind
Requires:       hivemind-lib
Requires:       javassist
Requires:       jcharts
Requires:       ognl >= 0:2.7.3

%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description
Tapestry is an open-source framework for creating dynamic, 
robust, highly scalable web applications in Java. Tapestry 
complements and builds upon the standard Java Servlet API, 
and so it works in any servlet container or application 
server. Tapestry divides a web application into a set of 
pages, each constructed from components. This provides a 
consistent structure, allowing the Tapestry framework to 
assume responsibility for key concerns such as URL 
construction and dispatch, persistent state storage on the 
client or on the server, user input validation, 
localization/internationalization, and exception reporting. 
Developing Tapestry applications involves creating HTML 
templates using plain HTML, and combining the templates 
with small amounts of Java code using (optional) XML 
descriptor files. In Tapestry, you create your application 
in terms of objects, and the methods and properties of those 
objects -- and specifically not in terms of URLs and query 
parameters. Tapestry brings true object oriented development 
to Java web applications. Tapestry is specifically designed 
to make creating new components very easy, as this is a 
routine approach when building applications. The distribution 
includes over fifty components, ranging from simple output 
components all the way up to complex data grids and tree 
navigators. Tapestry is architected to scale from tiny 
applications all the way up to massive applications consisting 
of hundreds of individual pages, developed by large, diverse 
teams. Tapestry easily integrates with any kind of backend, 
including J2EE, HiveMind and Spring.


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package demo
Summary:        Examples for %{name}
Group:          Development/Libraries/Java

%description demo
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q 
%patch0 -b .sav0
%patch1 -b .sav1

cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP


%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}
#
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/tapestry/tapestry-annotations/%{version}/
ln -sf $(pwd)/tapestry-annotations/target/tapestry-annotations-%{version}.jar \
   ${MAVEN_REPO_LOCAL}/org/apache/tapestry/tapestry-annotations/%{version}/tapestry-annotations-%{version}.jar
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/tapestry/tapestry-contrib/%{version}/
ln -sf $(pwd)/tapestry-contrib/target/tapestry-contrib-%{version}.jar \
   ${MAVEN_REPO_LOCAL}/org/apache/tapestry/tapestry-contrib/%{version}/tapestry-contrib-%{version}.jar
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/tapestry/tapestry-framework/%{version}/
ln -sf $(pwd)/tapestry-framework/target/tapestry-framework-%{version}.jar \
   ${MAVEN_REPO_LOCAL}/org/apache/tapestry/tapestry-framework/%{version}/tapestry-framework-%{version}.jar
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/tapestry/tapestry-portlet/%{version}/
ln -sf $(pwd)/tapestry-portlet/target/tapestry-portlet-%{version}.jar \
   ${MAVEN_REPO_LOCAL}/org/apache/tapestry/tapestry-portlet/%{version}/tapestry-portlet-%{version}.jar

export M_OPTS="-Dmaven2.jpp.mode=true -Dmaven2.jpp.depmap.file=%{SOURCE2} -Dmaven.repo.local=${MAVEN_REPO_LOCAL}"
export MAVEN_OPTS="${M_OPTS} -Dmaven.test.skip=true"
%{_bindir}/mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        package 

%{_bindir}/mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        javadoc:javadoc site

%{_bindir}/mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        package assembly:assembly

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 tapestry-annotations/target/tapestry-annotations-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/annotations-%{version}.jar
install -m 644 tapestry-archetype/target/tapestry-archetype-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/archetype-%{version}.jar
install -m 644 tapestry-contrib/target/tapestry-contrib-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/contrib-%{version}.jar
install -m 644 tapestry-framework/target/tapestry-framework-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/framework-%{version}.jar
install -m 644 tapestry-portlet/target/tapestry-portlet-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/portlet-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
# Install pom files
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-project.pom
%add_to_maven_depmap org.apache.tapestry tapestry-project %{version} JPP/%{name} project
install -m 644 tapestry-annotations/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-annotations.pom
%add_to_maven_depmap org.apache.tapestry tapestry-annotations %{version} JPP/%{name} annotations
install -m 644 tapestry-archetype/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-archetype.pom
%add_to_maven_depmap org.apache.tapestry tapestry-archetype %{version} JPP/%{name} archetype
install -m 644 tapestry-contrib/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib.pom
%add_to_maven_depmap org.apache.tapestry tapestry-contrib %{version} JPP/%{name} contrib
install -m 644 tapestry-framework/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-framework.pom
%add_to_maven_depmap org.apache.tapestry tapestry-framework %{version} JPP/%{name} framework
install -m 644 tapestry-portlet/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-portlet.pom
%add_to_maven_depmap org.apache.tapestry tapestry-portlet %{version} JPP/%{name} portlet

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf target/site/apidocs
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p *.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# Install war files
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 tapestry-examples/TimeTracker/target/tapestry-TimeTracker-%{version}.war \
               $RPM_BUILD_ROOT%{_datadir}/%{name}/
install -m 644 tapestry-examples/Workbench/target/tapestry-Workbench-%{version}.war \
               $RPM_BUILD_ROOT%{_datadir}/%{name}/

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root)
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%doc %{_docdir}/%{name}-%{version}/*.txt
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/*

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/site

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}

%changelog
* Sat Jan 22 2011 Ralph Apel <r.apel@r-apel.de> - 0:4.1.6-1
- 4.1.6 as tapestry4

